diff -uart fltk-1.3.4-1/src/Fl.cxx fltk-1.3.4-1-new/src/Fl.cxx
--- fltk-1.3.4-1/src/Fl.cxx	2016-03-08 17:58:43.000000000 +0100
+++ fltk-1.3.4-1-new/src/Fl.cxx	2017-04-22 10:16:22.686929612 +0200
@@ -970,7 +970,6 @@
 */
 void Fl::focus(Fl_Widget *o) {
   if (o && !o->visible_focus()) return;
-  if (grab()) return; // don't do anything while grab is on
   Fl_Widget *p = focus_;
   if (o != p) {
     Fl::compose_reset();
@@ -1028,7 +1027,6 @@
     handle()).
 */
 void Fl::belowmouse(Fl_Widget *o) {
-  if (grab()) return; // don't do anything while grab is on
   Fl_Widget *p = belowmouse_;
   if (o != p) {
     belowmouse_ = o;
@@ -1073,8 +1071,6 @@
   puts("fl_fix_focus();");
 #endif // DEBUG
 
-  if (Fl::grab()) return; // don't do anything while grab is on.
-
   // set focus based on Fl::modal() and fl_xfocus
   Fl_Widget* w = fl_xfocus;
   if (w) {
@@ -1305,7 +1301,7 @@
   switch (e) {
 
   case FL_CLOSE:
-    if ( grab() || (modal() && window != modal()) ) return 0;
+    if (modal() && window != modal()) return 0;
     wi->do_callback();
     return 1;
 
@@ -1415,7 +1411,8 @@
     // make sure that the widget still exists before sending
     // a KEYUP there. I believe that the current solution is
     // "close enough".
-    for (wi = grab() ? grab() : focus(); wi; wi = wi->parent())
+    if (grab() && send_event(FL_KEYUP, wi, window)) return 1;
+    for (wi = focus(); wi; wi = wi->parent())
       if (send_event(FL_KEYUP, wi, window)) return 1;
     return 0;
 
@@ -1429,7 +1426,8 @@
     fl_xfocus = window; // this should not happen!  But maybe it does:
 
     // Try it as keystroke, sending it to focus and all parents:
-    for (wi = grab() ? grab() : focus(); wi; wi = wi->parent())
+    if (grab() && send_event(FL_KEYBOARD, wi, window)) return 1;
+    for (wi = focus(); wi; wi = wi->parent())
       if (send_event(FL_KEYBOARD, wi, window)) return 1;
 
     // recursive call to try shortcut:
diff -uart fltk-1.3.4-1/src/fl_show_colormap.cxx fltk-1.3.4-1-new/src/fl_show_colormap.cxx
--- fltk-1.3.4-1/src/fl_show_colormap.cxx	2012-11-20 13:29:46.000000000 +0100
+++ fltk-1.3.4-1-new/src/fl_show_colormap.cxx	2017-04-20 19:39:52.461339024 +0200
@@ -135,8 +135,8 @@
     position(Fl::event_x_root()-(initial%8)*BOXSIZE-BOXSIZE/2-BORDER,
              Fl::event_y_root()-(initial/8)*BOXSIZE-BOXSIZE/2-BORDER);
   }
-  show();
   Fl::grab(*this);
+  show();
   done = 0;
   while (!done) Fl::wait();
   Fl::grab(0);
diff -uart fltk-1.3.4-1/src/Fl_Tooltip.cxx fltk-1.3.4-1-new/src/Fl_Tooltip.cxx
--- fltk-1.3.4-1/src/Fl_Tooltip.cxx	2015-09-01 16:27:45.000000000 +0200
+++ fltk-1.3.4-1-new/src/Fl_Tooltip.cxx	2017-04-23 10:20:22.079501107 +0200
@@ -156,9 +156,6 @@
       if (window) window->hide();
     } else {
       int condition = 1;
-#if !(defined(__APPLE__) || defined(WIN32))
-      condition = (Fl::grab() == NULL);
-#endif
       if ( condition ) {
         if (!window) window = new Fl_TooltipBox;
         // this cast bypasses the normal Fl_Window label() code:
